local agent_helper = require(AGENT_PATH .. "agent_helper")


function PlatformAdapter:OpenExitDialog()
	agent_helper:Exit(function(result)
			AdapterToLua:endGame()
	end)
end

AgentAdapter = {
	is_init = false,
	login_callback = nil,
	force_logout = false,
	is_login_verify_ing = false,
	login_verify_url = "cls.mg05.youyannet.com/ah3/login_verify.php",
	pay_callback_url = "http://cls.mg05.youyannet.com/ah3/pay_callback.php",
	pay_notify_callback_url = "",
	gameId = "6077",
	uid = "",
}

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	self.is_init = true
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "ah3"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "ah3_" .. self.uid
end

-- 是否有管理中心
function AgentAdapter:IsHasManagerCenter()
	return true
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[6]
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_wsws"
end

function AgentAdapter:OpenManagerCenter()
	if self:IsHasManagerCenter() and agent_helper.OpenManagerCenter then
		agent_helper:OpenManagerCenter()
	end
end


function AgentAdapter:Login(callback)
	self.login_callback = callback
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end

function AgentAdapter:LoginCallback(result)
	Log("LoginCallback:result=" .. result)
	local json_obj = cjson.decode(result)

	local verify_callback = function(url, arg, data, size)
		self.is_login_verify_ing = false
		if size <= 0 then
			Log("verify_callback, fail:size<=0")
			return
		end

		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			Log("verify_callback, fail")
			return
		end

		Log("login-verify, success")
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())
	end

	self.is_login_verify_ing = true

	local real_url = ""
	real_url = string.format("%s?spid=%s&token=%s&ssoid=%s&device=%s", self.login_verify_url, self:GetSpid(),json_obj.token, json_obj.ssoid, tostring(PlatformAdapter.GetPhoneUniqueId()))
	
	
	Log("start verify login: url=" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)
end

function AgentAdapter:LogoutCallback(result)
	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
end

function AgentAdapter:Logout()
	self.force_logout = true
	agent_helper:Logout()
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)


	local data = {}
	data.amount = amount * 100
	data.order = server_id .. "_" .. self.uid .. "_" .. os.time()
	data.desc = "游戏支付"
	data.goods_name = "元宝"
	data.call_back_url = self.pay_callback_url
	agent_helper:Pay(cjson.encode(data), callback)
end

function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)

	local info = {}
	info.gameId = self.gameId
	info.service = zone_id;
	info.role = role_name;
	info.grade = role_level;
	PlatformBinder:JsonCall("call_agent_submit_extend_data", cjson.encode(info))

end

-- 是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

