 local agent_helper = require(AGENT_PATH .. "agent_helper")



function PlatformAdapter:OpenExitDialog()

	local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }

	self:OpenAlertDialog(format, function (result) if "positive" == result then 

			agent_helper:Exit(function(result) 
				if "true" == result then
					Log("================ExitExitExitExit")
					AdapterToLua:endGame()
				end
			end)

	end end)

end


AgentAdapter = {
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.mg05.youyannet.com/ah5/login_verify.php",

	uid = "",
}

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	self.is_init = true
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")

	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "ah5"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid().."_" .. self.uid
end


--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[7] --我欲封魔
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_empty"
end


function AgentAdapter:LoginCallback(result)
	Log("AgentAdapter:LoginCallback========================:" .. result)
	local json_obj = cjson.decode(result)

	if nil == json_obj or nil == json_obj.uid or nil == json_obj.sid then return end
	self.uid = json_obj.uid
	self.sid = json_obj.sid
	self.login_callback(self:GetPlatName(), self.sid)
	return false
end

function AgentAdapter:Login(callback)
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end

function AgentAdapter:LogoutCallback(result)
	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:Logout()
	self.force_logout = true
	agent_helper:Logout()
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)
	Log("============AgentAdapter:Pay1111===========")
	
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end
	
	local json_obj = {}
	json_obj.amount = amount
	json_obj.order = server_id .. "_" .. self.uid .. "_" .. os.time()
	agent_helper:Pay(cjson.encode(json_obj), nil)
	Log(cjson.encode(json_obj) .. "========222222222=======")
end


--元宝变化
function AgentAdapter:OnMoneyChange(gold)
	Log("OnMoneyChange==================")
	Log(gold)
	PlatformBinder:JsonCall("call_agent_on_money_change", gold)
end


function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)

	if self.subit_date_tf == nil then
		self.subit_date_tf = true
		local info = {}

		info.action = 1
		if self.createRole then
			info.action = 2
			self.createRole = nil
			self.subit_date_tf = nil
		end

		info.serverId = zone_id
		info.serverName = zone_name
		info.role_id = role_id
		info.role_name = role_name
		info.role_level = role_level

		self.serverId = zone_id
		self.serverName = zone_name

		PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
	end

end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)

	print("创建角色上报----ReportOnCreateRole")

	self.createRole = true

end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end