local agent_helper = {
	LOGLEVEL_ERROR = 0,	--错误信息级别，记录错误日志
	LOGLEVEL_WARN = 1,	--警告信息级别，记录错误和警告日志
	LOGLEVEL_DEBUG = 2,	--调试信息级别，记录错误、警告和调试信息，为最详尽的日志级别

	cp_id = 28559,
	game_id = 551645,
}

--void (*UCCallback)(int code, const char *pszmsg);

-- static void initSDK(bool debugMode, int logLevel, int cpId, int gameId,
-- 	int serverId, const char *pszServerName, bool enablePayHistory,
-- 	bool enableLogout, UCCallback initResultCallback)

function agent_helper:Init(callback)
	local param = cjson.encode(
	{
		logLevel = agent_helper.LOGLEVEL_DEBUG,
		debugMode = false,
		cpId = self.cp_id,
		gameId = self.game_id,
		enablePayHistory = true,
		enableLogout = true,
	} )
	PlatformBinder:JsonCall("call_agent_init", param, "", callback)
end

function agent_helper:Login(callback)
	PlatformBinder:JsonCall("call_agent_login", "", "", callback)
end

function agent_helper:GetSessionId()
	return PlatformBinder:JsonCall("call_agent_get_sid")
end

function agent_helper:Logout()
	PlatformBinder:JsonCall("call_agent_logout")
end

function agent_helper:SetLogoutCallback(callback)
	PlatformBinder:JsonBind("event_agent_logout", callback)
end

function agent_helper:Exit(callback)
	PlatformBinder:JsonCall("call_agent_exit", "", "", callback)
end

function agent_helper:SetUIEventCallback(callback)
	PlatformBinder:JsonBind("event_agent_sdk_ui", callback)
end

function agent_helper:ShowFloatButton(x, y, visable)
	local param = cjson.encode({["x"] = x, ["y"] = y, ["visable"] = visable})
	PlatformBinder:JsonCall("call_agent_show_float_button", param);
end

function agent_helper:Pay(param, callback)
	PlatformBinder:JsonCall("call_agent_pay", param, "", callback)
end

function agent_helper:SubmitExtendData(type, data)
	local param = cjson.encode({["type"] = type, ["data"] = data})
	PlatformBinder:JsonCall("call_agent_submit_extend_data", param)
end

function agent_helper:EnterUserCenter(callback)
	PlatformBinder:JsonCall("call_agent_enter_user_center", param, "", callback)
end

return agent_helper 
