local agent_helper = require(AGENT_PATH .. "agent_helper")


function PlatformAdapter:OpenExitDialog()

	local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }

	self:OpenAlertDialog(format, function (result) if "positive" == result then 

			agent_helper:Exit(function(result) 
				if "true" == result then
					Log("================ExitExitExitExit")
					AdapterToLua:endGame()
				end
			end)

	end end)

end



AgentAdapter = {
	is_init = false,
	login_callback = nil,
	force_logout = false,
	--login_verify_url = "cls.cp01.youyannet.com/ah8/login_verify.php",
	create_order_url = "cls.mg05.youyannet.com/ah8/create_order.php",

	uid = "",
}

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "ah8"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "ah8_" .. self.uid
end

function AgentAdapter:Login(callback)
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end

function AgentAdapter:OnClickBackLogin()
	Log("OnClickBtnLogin, logout")
	agent_helper:Logout()
end



function AgentAdapter:LoginCallback(result)
	local json_obj = cjson.decode(result)

	if nil == json_obj or nil == json_obj.amigoToken or nil == json_obj.playerId then return end
	self.uid = json_obj.playerId
	self.login_callback(self:GetPlatName(), json_obj.amigoToken)
	return false
end


-- function AgentAdapter:LoginCallback(result)
-- 	if "true" == result then return true end

	
-- 	local verify_callback = function(url, arg, data, size)
-- 		self.is_login_verify_ing = false
-- 		if size <= 0 then
-- 			Log("verify_callback, fail:size<=0")
-- 			return
-- 		end

-- 		local ret_t = cjson.decode(data)
-- 		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
-- 			Log("verify_callback, fail")
-- 			return
-- 		end

-- 		Log("login-verify, success")
-- 		self:ShowFloatButton()
-- 		self.uid = ret_t.user.uid
-- 		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
-- 		self.login_callback(self:GetPlatName())
-- 	end

-- 	self.is_login_verify_ing = true
	
-- 	local session_id = agent_helper:GetSessionId()
-- 	local now_server_time = math.floor(GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time))
-- 	local sign = UtilEx:md5Data(self:GetSpid() .. session_id .. now_server_time .. LOGIN_VERIFY_KEY)
-- 	local real_url = string.format("%s?spid=%s&sid=%s&time=%s&sign=%s", self.login_verify_url, self:GetSpid(), session_id, now_server_time, sign)
-- 	Log("start verify login: url=" .. real_url)
-- 	HttpClient:Request(real_url, "", verify_callback)

-- 	return false
-- end









function AgentAdapter:LogoutCallback(result)
	Log("AgentAdapter:LogoutCallback")
	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:Logout()
	self.force_logout = true
	agent_helper:Logout()
end

function AgentAdapter:UIEventCallback(event)
	if "open" == event then
		--self:ShowFloatButton()
	elseif "close" == event then
		--self:ShowFloatButton()
	end
	return true
end

function AgentAdapter:ShowFloatButton()
	agent_helper:ShowFloatButton(70, 30, true)
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)

	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end
	
	self:CreateOrder(server_id, amount)
end

function AgentAdapter:CreateOrder(server_id, amount)
	local create_order_callback = function(url, arg, data, size)
		Log("create order callback" .. data)
		if size <= 0 then
			Log("create_order_callback, fail:size<=0")
			return
		end
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret then
			SysMsgCtrl.Instance:ErrorRemind("创建订单失败:" .. ret_t.out_order_no, true)
			Log("create_order_callback, fail")
			return
		end

		local param_obj = {}
		param_obj.order = ret_t.out_order_no
		param_obj.time = ret_t.submit_time

		Log(cjson.encode(param_obj))

		agent_helper:Pay(cjson.encode(param_obj), nil)
	end

	local order = server_id .. "_" .. self.uid .. "_" .. os.time()
	local real_url = string.format("%s?order=%s&money=%s&uid=%s", self.create_order_url, order, amount, self.uid)
	Log("start Create order" .. real_url)
	HttpClient:Request(real_url, "", create_order_callback)
end


--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[7]
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_empty"
end


--元宝变化
function AgentAdapter:OnMoneyChange(gold)
	Log("OnMoneyChange==================")
	Log(gold)
	PlatformBinder:JsonCall("call_agent_on_money_change", gold)
end

function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)

	if self.subit_date_tf == nil then
		self.subit_date_tf = true
		local info = {}

		info.action = 1
		if self.createRole then
			info.action = 2
			self.createRole = nil
			self.subit_date_tf = nil
		end

		info.serverId = zone_id
		info.serverName = zone_name
		info.role_id = role_id
		info.role_name = role_name
		info.role_level = role_level

		self.serverId = zone_id
		self.serverName = zone_name

		PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
	end

end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)

	print("创建角色上报----ReportOnCreateRole")

	self.createRole = true

end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end



agent_helper:SetLogoutCallback(LUA_CALLBACK(AgentAdapter, AgentAdapter.LogoutCallback))
agent_helper:SetUIEventCallback(LUA_CALLBACK(AgentAdapter, AgentAdapter.UIEventCallback))
